# std::vector< _Tp, _Alloc > Class Template Reference
[Containers, Sequences]

A standard container which offers fixed time access to individual elements in any order. More...

`#include <stl_vector.h>`

Inheritance diagram for std::vector< _Tp, _Alloc >:

[legend]
List of all members.

## Public Methods

| vector (const allocator_type &__a=allocator_type())
| Default constructor creates no elements.
| vector (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
| Create a %vector with copies of an exemplar element.
| vector (size_type __n)
| Create a %vector with default elements.
| vector (const vector &__x)
| %Vector copy constructor.
template<typename _InputIterator> | vector (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
| Builds a %vector from a range.
| ~vector ()
vector & | operator= (const vector &__x)
| %Vector assignment operator.
void | assign (size_type __n, const value_type &__val)
| Assigns a given value to a %vector.
template<typename _InputIterator> void | assign (_InputIterator __first, _InputIterator __last)
| Assigns a range to a %vector.
allocator_type | get_allocator () const
| Get a copy of the memory allocation object.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
size_type | max_size () const
void | resize (size_type __new_size, const value_type &__x)
| Resizes the %vector to the specified number of elements.
void | resize (size_type __new_size)
| Resizes the %vector to the specified number of elements.
size_type | capacity () const
bool | empty () const
void | reserve (size_type __n)
| Attempt to preallocate enough memory for specified number of elements.
reference | operator[] (size_type __n)
| Subscript access to the data contained in the %vector.
const_reference | operator[] (size_type __n) const
| Subscript access to the data contained in the %vector.
reference | at (size_type __n)
| Provides access to the data contained in the %vector.
const_reference | at (size_type __n) const
| Provides access to the data contained in the %vector.
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push_back (const value_type &__x)
| Add data to the end of the %vector.
void | pop_back ()
| Removes last element.
iterator | insert (iterator __position, const value_type &__x)
| Inserts given value into %vector before specified iterator.
iterator | insert (iterator __position)
| Inserts an element into the %vector.
void | insert (iterator __pos, size_type __n, const value_type &__x)
| Inserts a number of copies of given data into the %vector.
template<typename _InputIterator> void | insert (iterator __pos, _InputIterator __first, _InputIterator __last)
| Inserts a range into the %vector.
iterator | erase (iterator __position)
| Remove element at given position.
iterator | erase (iterator __first, iterator __last)
| Remove a range of elements.
void | swap (vector &__x)
| Swaps data with another %vector.
void | clear ()

## Detailed Description

### template<typename _Tp, typename _Alloc = allocator<_Tp>>
class std::vector< _Tp, _Alloc >

A standard container which offers fixed time access to individual elements in any order.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the %exception of `push_front` and `pop_front.`

In some terminology a %vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( `[]` ) access is also provided as with C-style arrays.

Definition at line 185 of file stl_vector.h.

## Constructor & Destructor Documentation

template<typename _Tp, typename _Alloc = allocator<_Tp>>
std::vector< _Tp, _Alloc >::vector | ( | const allocator_type & | __a = allocator_type() | ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 228 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
std::vector< _Tp, _Alloc >::vector | ( | size_type | __n,
|  | const value_type & | __value,
|  | const allocator_type & | __a = allocator_type()
| ) | `[inline]`

Create a %vector with copies of an exemplar element.

Parameters:

  n | The number of elements to initially create.
  value | An element to copy.

This constructor fills the %vector with n copies of value.

Definition at line 238 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
std::vector< _Tp, _Alloc >::vector | ( | size_type | __n | ) | `[inline, explicit]`

Create a %vector with default elements.

Parameters:

  n | The number of elements to initially create.

This constructor fills the %vector with n copies of a default-constructed element.

Definition at line 251 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
std::vector< _Tp, _Alloc >::vector | ( | const vector< _Tp, _Alloc > & | __x | ) | `[inline]`

%Vector copy constructor.

Parameters:

  x | A %vector of identical element and allocator types.

The newly-created %vector uses a copy of the allocation object used by x. All the elements of x are copied, but any extra memory in x (for fast expansion) will not be copied.

Definition at line 264 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
template<typename _InputIterator>
std::vector< _Tp, _Alloc >::vector | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = allocator_type()
| ) | `[inline]`

Builds a %vector from a range.

Parameters:

  first | An input iterator.
  last | An input iterator.

Create a %vector consisting of copies of the elements from [first,last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 283 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
std::vector< _Tp, _Alloc >::~vector | ( |  | ) | `[inline]`

| The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 297 of file stl_vector.h.

## Member Function Documentation

template<typename _Tp, typename _Alloc = allocator<_Tp>>
template<typename _InputIterator>
void std::vector< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

Assigns a range to a %vector.

Parameters:

  first | An input iterator.
  last | An input iterator.

This function fills a %vector with copies of the elements in the range [first,last).

Note that the assignment completely changes the %vector and that the resulting %vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 338 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val
| ) | `[inline]`

Assigns a given value to a %vector.

Parameters:

  n | Number of elements to be assigned.
  val | Value to be assigned.

This function fills a %vector with n copies of the given value. Note that the assignment completely changes the %vector and that the resulting %vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 321 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the %vector.

Parameters:

  n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

Exceptions:

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 553 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the %vector.

Parameters:

  n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

Exceptions:

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 539 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::back | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the last element of the %vector. Definition at line 581 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::back | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the last element of the %vector. Definition at line 574 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_iterator std::vector< _Tp, _Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first element in the %vector. Iteration is done in ordinary element order. Definition at line 363 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first element in the %vector. Iteration is done in ordinary element order.

Definition at line 355 of file stl_vector.h.

Referenced by std::vector< _Node *, _Alloc >::capacity() , std::vector< _Node *, _Alloc >::clear() , std::vector< _Node *, _Alloc >::empty() , std::vector< _Node *, _Alloc >::front() , std::vector< _Tp, _Alloc >::insert() , std::vector< _Tp, _Alloc >::operator=() , std::operator==() , std::vector< _Node *, _Alloc >::operator[]() , std::vector< _Node *, _Alloc >::rend() , std::vector< _Node *, _Alloc >::resize() , and std::vector< _Node *, _Alloc >::size() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
size_type std::vector< _Tp, _Alloc >::capacity | ( |  | ) | const`[inline]`

| Returns the total number of elements that the %vector can hold before needing to allocate more memory. Definition at line 459 of file stl_vector.h. Referenced by std::vector< _Tp, _Alloc >::operator=() , and std::vector< _Tp, _Alloc >::reserve() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::clear | ( |  | ) | `[inline]`

| Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 759 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
bool std::vector< _Tp, _Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the %vector is empty. (Thus begin() would equal end().) Definition at line 467 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_iterator std::vector< _Tp, _Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last element in the %vector. Iteration is done in ordinary element order. Definition at line 378 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last element in the %vector. Iteration is done in ordinary element order.

Definition at line 371 of file stl_vector.h.

Referenced by std::vector< _Node *, _Alloc >::back() , std::vector< _Node *, _Alloc >::clear() , std::vector< _Node *, _Alloc >::empty() , std::vector< _Tp, _Alloc >::erase() , std::vector< _Tp, _Alloc >::insert() , std::vector< _Tp, _Alloc >::operator=() , std::operator==() , std::vector< _Node *, _Alloc >::push_back() , std::vector< _Node *, _Alloc >::rbegin() , std::vector< _Node *, _Alloc >::resize() , and std::vector< _Node *, _Alloc >::size() .

template<typename _Tp, typename _Alloc>
vector< _Tp, _Alloc >::iterator std::vector< _Tp, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last
| ) |

Remove a range of elements.

Parameters:

  first | Iterator pointing to the first element to be erased.
  last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the %vector accordingly.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 116 of file vector.tcc.

References std::copy() , and std::vector< _Tp, _Alloc >::end() .

template<typename _Tp, typename _Alloc>
vector< _Tp, _Alloc >::iterator std::vector< _Tp, _Alloc >::erase | ( | iterator | __position | ) |

Remove element at given position.

Parameters:

  position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the %vector by one.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 104 of file vector.tcc.

References std::copy() , and std::vector< _Tp, _Alloc >::end() .

Referenced by std::vector< _Node *, _Alloc >::clear() , and std::vector< _Node *, _Alloc >::resize() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::front | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the %vector. Definition at line 567 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::front | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the %vector. Definition at line 560 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
allocator_type std::vector< _Tp, _Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 347 of file stl_vector.h. Referenced by std::vector< _Node *, _Alloc >::vector() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
template<typename _InputIterator>
void std::vector< _Tp, _Alloc >::insert | ( | iterator | __pos,
|  | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

Inserts a range into the %vector.

Parameters:

  pos | An iterator into the %vector.
  first | An input iterator.
  last | An input iterator.

This function will insert copies of the data in the range [first,last) into the %vector before the location specified by pos.

Note that this kind of operation could be expensive for a %vector and if it is frequently used the user should consider using std::list.

Definition at line 689 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::insert | ( | iterator | __pos,
|  | size_type | __n,
|  | const value_type & | __x
| ) | `[inline]`

Inserts a number of copies of given data into the %vector.

Parameters:

  position | An iterator into the %vector.
  n | Number of elements to be inserted.
  x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Note that this kind of operation could be expensive for a %vector and if it is frequently used the user should consider using std::list.

Definition at line 670 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
iterator std::vector< _Tp, _Alloc >::insert | ( | iterator | __position | ) | `[inline]`

Inserts an element into the %vector.

Parameters:

  position | An iterator into the %vector.

Returns:
  An iterator that points to the inserted element.

This function will insert a default-constructed element before the specified location. You should consider using insert(position,value_type()) instead. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Note:
  This was deprecated in 3.2 and will be removed in 3.4. You must define `_GLIBCPP_DEPRECATED` to make this visible in 3.2; see c++config.h.

Definition at line 652 of file stl_vector.h.

template<typename _Tp, typename _Alloc>
vector< _Tp, _Alloc >::iterator std::vector< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | const value_type & | __x
| ) |

Inserts given value into %vector before specified iterator.

Parameters:

  position | An iterator into the %vector.
  x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Note that this kind of operation could be expensive for a %vector and if it is frequently used the user should consider using std::list.

Definition at line 88 of file vector.tcc.

References std::vector< _Tp, _Alloc >::begin() , and std::vector< _Tp, _Alloc >::end() .

Referenced by std::vector< _Node *, _Alloc >::insert() , and std::vector< _Node *, _Alloc >::resize() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
size_type std::vector< _Tp, _Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the size() of the largest possible %vector. Definition at line 419 of file stl_vector.h. Referenced by std::vector< _Tp, _Alloc >::reserve() .

template<typename _Tp, typename _Alloc>
vector< _Tp, _Alloc > & std::vector< _Tp, _Alloc >::operator= | ( | const vector< _Tp, _Alloc > & | __x | ) |

%Vector assignment operator.

Parameters:

  x | A %vector of identical element and allocator types.

All the elements of x are copied, but any extra memory in x (for fast expansion) will not be copied. Unlike the copy constructor, the allocator object is not copied.

Definition at line 127 of file vector.tcc.

References std::vector< _Tp, _Alloc >::begin() , std::vector< _Tp, _Alloc >::capacity() , std::copy() , std::vector< _Tp, _Alloc >::end() , std::vector< _Tp, _Alloc >::size() , and std::uninitialized_copy() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_reference std::vector< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const`[inline]`

Subscript access to the data contained in the %vector.

Parameters:

  n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 515 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
reference std::vector< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | `[inline]`

Subscript access to the data contained in the %vector.

Parameters:

  n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 501 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::pop_back | ( |  | ) | `[inline]`

| Removes last element. This is a typical stack operation. It shrinks the %vector by one. Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called. Definition at line 615 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) | `[inline]`

Add data to the end of the %vector.

Parameters:

  x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the %vector and assigns the given data to it. Due to the nature of a %vector this operation can be done in constant time if the %vector has preallocated space available.

Definition at line 595 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_reverse_iterator std::vector< _Tp, _Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last element in the %vector. Iteration is done in reverse element order. Definition at line 394 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
reverse_iterator std::vector< _Tp, _Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last element in the %vector. Iteration is done in reverse element order. Definition at line 386 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
const_reverse_iterator std::vector< _Tp, _Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first element in the %vector. Iteration is done in reverse element order. Definition at line 410 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
reverse_iterator std::vector< _Tp, _Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first element in the %vector. Iteration is done in reverse element order. Definition at line 402 of file stl_vector.h.

template<typename _Tp, typename _Alloc>
void std::vector< _Tp, _Alloc >::reserve | ( | size_type | __n | ) |

Attempt to preallocate enough memory for specified number of elements.

Parameters:

  n | Number of elements required.

Exceptions:

  std::length_error | If n exceeds `max_size().`

This function attempts to reserve enough memory for the %vector to hold the specified number of elements. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the number of elements that will be required, the user can reserve the memory in %advance, and thus prevent a possible reallocation of memory and copying of %vector data.

Definition at line 69 of file vector.tcc.

References std::vector< _Tp, _Alloc >::capacity() , std::vector< _Tp, _Alloc >::max_size() , and std::vector< _Tp, _Alloc >::size() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::resize | ( | size_type | __new_size | ) | `[inline]`

Resizes the %vector to the specified number of elements.

Parameters:

  new_size | Number of elements the %vector should contain.

This function will resize the %vector to the specified number of elements. If the number is smaller than the %vector's current size the %vector is truncated, otherwise the %vector is extended and new elements are default-constructed.

Definition at line 452 of file stl_vector.h.

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | const value_type & | __x
| ) | `[inline]`

Resizes the %vector to the specified number of elements.

Parameters:

  new_size | Number of elements the %vector should contain.
  x | Data with which new elements should be populated.

This function will %resize the %vector to the specified number of elements. If the number is smaller than the %vector's current size the %vector is truncated, otherwise the %vector is extended and new elements are populated with given data.

Definition at line 433 of file stl_vector.h.

Referenced by std::vector< _Node *, _Alloc >::resize() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
size_type std::vector< _Tp, _Alloc >::size | ( |  | ) | const`[inline]`

| Returns the number of elements in the %vector. Definition at line 415 of file stl_vector.h. Referenced by std::vector< _Tp, _Alloc >::operator=() , std::operator==() , std::vector< _Tp, _Alloc >::reserve() , std::vector< _Node *, _Alloc >::resize() , and std::vector< _Node *, _Alloc >::vector() .

template<typename _Tp, typename _Alloc = allocator<_Tp>>
void std::vector< _Tp, _Alloc >::swap | ( | vector< _Tp, _Alloc > & | __x | ) | `[inline]`

Swaps data with another %vector.

Parameters:

  x | A %vector of the same element and allocator types.

This exchanges the elements between two vectors in constant time. (Three pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(v1,v2) will feed to this function.

Definition at line 745 of file stl_vector.h.

Referenced by std::swap() .

The documentation for this class was generated from the following files:

- stl_vector.h
- vector.tcc